global ChannelsList
ChannelsList = dict()
ChannelsListByName = dict()

class ChanType:
    SIP = 1
    LOCAL = 2

class Channel(dict):
    def __init__(self, uid, lid, userID, email, userExtension, groupID, groupName, phone, name, chanType, chanName, context):
        # print("====Init channel " + str(uid))
        self["uid"] = uid
        self["lid"] = lid
        self["userId"] = userID
        self["email"] = email
        self["userExtension"] = userExtension
        self["groupId"] = groupID
        self["groupName"] = groupName
        self["phone"] = phone
        self["name"] = name
        self["company"] = None
        self["chanType"] = chanType
        self["chanName"] = chanName
        self["context"] = context

    def set(self, param, value):
        if value != "" and value != self.get(param):
            self[param] = value   

    def get_info(self):
        rv = {}
        for attr in {"userId","email","userExtension","groupId","groupName","phone","name"}:
            value = self.get(attr)
            if value != None:
                rv[attr] = value
        return rv

def add(chan):
    ChannelsList[chan.get("uid")] = chan
    ChannelsListByName[chan.get("chanName")] = chan.get("uid")

def get(uid):
    return ChannelsList.get(uid)

def get_by_name(chanName):
    uid = ChannelsListByName.get(chanName)
    return ChannelsList.get(uid)

def uid_masquerade(uid1, uid2, lid):
    #print("\n >>> uid_masquerade dbg1 \n")
    chan1 = ChannelsList.get(uid1)
    chan2 = ChannelsList.get(uid2)
    if chan1 == None or chan2 == None:
        return
    chan1.set("uid", uid2)
    chan1.set("lid", lid)
    chan2.set("uid", uid1)
    chan2.set("lid", lid)
    ChannelsList[uid1] = chan2
    ChannelsList[uid2] = chan1
    ChannelsListByName[chan1.get("chanName")] = uid2
    ChannelsListByName[chan2.get("chanName")] = uid1

def end(uid):
    if uid in ChannelsList.keys():
        chanName = ChannelsList.get(uid).get("chanName")
        if chanName in ChannelsListByName.keys():
            del ChannelsListByName[chanName]
        del ChannelsList[uid]

def print_currect_state():
    res = "ChannelsList:"
    for c in ChannelsList.keys():
        res += "\n\n{}".format(ChannelsList[c])
    print("===={}".format(res))