import subprocess
import re
from ldap3 import Server, Connection, SAFE_SYNC

# LDAP
LDAP_USER = subprocess.getoutput("cat /etc/callweaver/res_ldap.conf | grep 'user=' | cut -d= -f 2,3,4")
LDAP_PASS = subprocess.getoutput("cat /etc/callweaver/res_ldap.conf | grep 'pass=' | cut -d= -f 2")
LDAP_SERVER = Server("localhost")
LDAP_CONN = None


def getUserInfo(number):
    global LDAP_CONN
    if LDAP_CONN is None:
        LDAP_CONN = Connection(LDAP_SERVER, LDAP_USER, LDAP_PASS, client_strategy=SAFE_SYNC, auto_bind=True)

    rv = {}
    status, _, response, _ = LDAP_CONN.search(search_base="dc=wildix",
                                              search_filter="(&(objectClass=wPerson)(|(telephoneNumber={})(mobile={})))".format(
                                                  number, number),
                                              attributes=["uid", "mail", "telephoneNumber", "owner", "userKind", "cn", "mobile"])
    if status is True and len(response) > 0:
        if len(response[0].get("attributes").get("uid")) > 0:
            rv["userID"] = response[0].get("attributes").get("uid")[0]
            gid = re.findall("^gid=(\d+),.*", response[0].get("attributes").get("owner")[0])
            if len(gid) > 0:
                rv["groupID"] = gid[0]
                rv["groupName"] = getUserGroupName(gid[0])
        if len(response[0].get("attributes").get("mail")) > 0:
            rv["email"] = response[0].get("attributes").get("mail")[0]
        if len(response[0].get("attributes").get("telephoneNumber")) > 0:
            rv["userExtension"] = response[0].get("attributes").get("telephoneNumber")[0]
        if len(response[0].get("attributes").get("userKind")) >0:
            rv["userKind"] = response[0].get("attributes").get("userKind")[0]
        if len(response[0].get("attributes").get("cn")) >0:
            rv["commonName"] = response[0].get("attributes").get("cn")[0]
        if len(response[0].get("attributes").get("mobile")) >0:
            rv["mobile"] = response[0].get("attributes").get("mobile")[0]
    return rv

def getUserGroupName(gid):    
    global LDAP_CONN
    if LDAP_CONN is None:
        LDAP_CONN = Connection(LDAP_SERVER, LDAP_USER, LDAP_PASS, client_strategy=SAFE_SYNC, auto_bind=True)

    rv = None
    status, _, response, _ = LDAP_CONN.search(search_base="dc=wildix",
                                              search_filter="(&(objectClass=wGroup)(gid={}))".format(gid),
                                              attributes=["cn"])
    if status is True and len(response) > 0:
        if len(response[0].get("attributes").get("cn")) > 0:
            rv = response[0].get("attributes").get("cn")[0]
    return rv